import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

public class main extends JPanel {
  // aplet pozostava z troch zakladnych veci:
  Buttons B;       // gombikov (dolu)
  Commentary C;    // komentara (vpravo)
  DataStructure D; // datovej struktury
  Screen S;        // a obrazovky v strede

  Locale locale;
  ResourceBundle msg;

  int STEPS=10;
  boolean pause=true, small=false;

  String d;
  public main(String d) {
    this.d = d;
    init();
  }

  public void init() {
    // Internationalization
    locale = new Locale ("en");
    msg = ResourceBundle.getBundle ("Messages", locale);

    // Screen
    JPanel screen = new JPanel();
    S = new Screen() {
      //public Dimension getPreferredSize() { return new Dimension(900, 400); }
      public Dimension getPreferredSize() { return new Dimension(400, 180); }
      //public Dimension getMinimumSize() { return new Dimension(600, 300); }
      public Dimension getMinimumSize() { return new Dimension(400, 200); }
    };
    screen.add(S);
    screen.setBorder(BorderFactory.createCompoundBorder(
      BorderFactory.createTitledBorder(msg.getString ("display")),
      BorderFactory.createEmptyBorder(5,5,5,5)));

    // Commentary
    C = new Commentary (msg) {
//      public Dimension getPreferredSize() { return new Dimension(250, 400); }
//      public Dimension getMinimumSize() { return new Dimension(200, 300); }
      public Dimension getPreferredSize() { return new Dimension(150, 310); }
      public Dimension getMinimumSize() { return new Dimension(100, 310); }
     };

    // Data Structure
//    String d = getParameter ("ds");
    if (d.equals ("bst")) D = new BST (this);
    else if (d.equals ("avl")) D = new AVL (this);
    else if (d.equals ("b-tree")) D = new BTree (this);
    else if (d.equals ("redblack")) D = new RB (this);
    else if (d.equals ("andersson")) D = new AA (this);
    else if (d.equals ("splay")) D = new Splay (this);
    else if (d.equals ("skiplist")) D = new SkipList (this);
    else if (d.equals ("treap")) D = new Treap (this);
    else if (d.equals ("scapegoat")) D = new GBTree (this);
    else if (d.equals ("heap")) D = new Heap (this);
    else D = new BST(this); 

    // Buttons
    B = new Buttons(this); // ! gombiky sa mozu inicializovat az PO dasi

    //
    JPanel left = new JPanel();
    left.setLayout(new BoxLayout(left, BoxLayout.PAGE_AXIS));
    left.add(screen);
    left.add(B); 

    JPanel right = new JPanel();
    right.add(C);
    right.setBorder(BorderFactory.createCompoundBorder(
      BorderFactory.createTitledBorder(msg.getString("text")),
      BorderFactory.createEmptyBorder(5,5,5,5)));

    setLayout (new FlowLayout());
    add (left);
    add (right);

    S.setDS (D);
    S.start();
  }
}
